#!/bin/sh
# You need to change settings here to match your system
# Run this as your postgres user
# This creates a postgres user called hordemgr which HORDE
# can use to make database calls
#
NEWUSER=hordemgr
SYSID=33
CANCREATE=f
CANADDUSER=f
PASSWORD=hordemgr
PSQL=/usr/bin/psql

RES=`$PSQL -t -c "SELECT count(*) FROM pg_shadow WHERE usename = 'hordemgr';" template1 | awk '{ print $1 }'`
if [ "$RES" != "0" ]; then
    echo "$0: user "\"$NEWUSER\"" already exists" 1>&2
    exit 1
fi

QUERY="insert into pg_shadow \
        (usename, usesysid, usecreatedb, usetrace, usesuper, usecatupd,passwd) \
       values \
         ('$NEWUSER', $SYSID, '$CANCREATE', 't', '$CANADDUSER','t','$PASSWORD');"

RES=`$PSQL -c "$QUERY" template1 | awk '/INSERT/ { print $3 }'`
if [ "$RES" != "1" ]; then
    echo "$0: failed adding user "\"$NEWUSER\"" " 1>&2
    exit 1
fi


